//%attributes = {"publishedWeb":true}
// Method : http_Closer
// This process takes care of closing streams gracefully

//**** Intialize arrays of stream to close

ARRAY LONGINT:C221($t_streamC; 0)
ARRAY LONGINT:C221($t_status; 0)
ARRAY LONGINT:C221($t_timeout; 0)

//**** Main close loop
Repeat 
	DELAY PROCESS:C323(Current process:C322; 60)
	
	// Is there a stream to release ?
	For ($i; 1; Size of array:C274($t_streamC))
		If ($t_StreamC{$i}#0)
			If ($t_status{$i}=-1)
				//Ready to release
				$err:=ITK_TCPRelease($t_StreamC{$i})
				$t_StreamC{$i}:=0
				$t_status{$i}:=0
			End if 
		End if 
	End for 
	
	// Receive new stream to close
	$time:=ITK_Date2Secs(Current date:C33; Current time:C178; 1)
	$nb:=ITK_NbIPCMsg(4)
	If ($nb>0)
		//Get the current timeout value
		$closeDelay:=Num:C11(u_GetParam("HTTP_CloseDelay"; "120"))
		
		Repeat 
			$msg:=ITK_RcvIPCMsg(4)
			If ($msg#"")
				//Check if don’t already have it
				$i:=Find in array:C230($t_streamC; 0)
				If ($i=-1)
					$i:=Size of array:C274($t_StreamC)+1  // increase our arrays size
					ARRAY LONGINT:C221($t_StreamC; $i)
					ARRAY LONGINT:C221($t_Status; $i)
					ARRAY LONGINT:C221($t_timeout; $i)
				End if 
				$t_StreamC{$i}:=Num:C11($msg)
				$t_timeout{$i}:=$time  //Start the timeout counter
				$err:=ITK_TCPClose($t_StreamC{$i})
			End if 
		Until ($msg="")
	End if 
	
	//Check the status of the closing streams
	$nb:=0
	$i:=ITK_TCPStatus2A($t_streamC; $t_status)
	
	For ($i; 1; Size of array:C274($t_streamC))
		If ($t_StreamC{$i}#0)  // stream valid ?
			Case of 
				: ($time>($t_timeout{$i}+$closeDelay))
					$t_status{$i}:=-1
					
				: (($t_status{$i}<0) | ($t_status{$i}>12))
					//Status = ready to release
					$t_status{$i}:=-1  //we will release it next time
					
				: (($t_status{$i}=12) & ($t_timeout{$i}>($time+10)))
					//Reduce the time out length if status = 12
					$t_timeout{$i}:=$time+5
					
			End case 
		End if 
	End for 
	
Until (<>HTTP_stop)