//%attributes = {"publishedWeb":true}
// Method : http_Master
// This process listens for incoming connections and pass
// them to the "delivery" processes

//**** initialize the parameters
//a - Size of TCP buffers (only used with MacTCP)
$webBuff:=Num:C11(u_GetParam("WebBuff"; "8192"))
If ($webBuff<0)
	$webBuff:=0
End if 
//b- Number of delivery process
$numHTTP:=Num:C11(u_GetParam("HTTP_NumProcess"; "6"))
//c- Number of streams to listen on
$numStream:=Num:C11(u_GetParam("HTTP_NumStream"; String:C10(2*$numHTTP)))
//d- Array for our  list of streams
ARRAY LONGINT:C221($t_stream; $numStream)
ARRAY LONGINT:C221($t_status; $numStream)

//**** Launch the delivery processes
For ($i; 1; $numHTTP)
	$p:=New process:C317("http_Slave"; 64000; "http_Slave")
End for 

//**** Open the stream on which to listen
For ($i; 1; $numStream)
	If (<>useSSL)
		$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff; kITKSSLListenStream)
		If (<>usePW)
			$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey; <>SSLPassword; <>SSLcertificateINT)  //********************** ITK_SSLSetCert Added
		Else 
			$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey)  //********************** ITK_SSLSetCert Added
		End if 
	Else 
		$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff)
	End if 
End for 

//**** Start of the main loop
Repeat 
	
	//Redo a listen for used up streams
	$i:=Find in array:C230($t_stream; 0)
	If ($i>0)
		If (<>useSSL)
			$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff; kITKSSLListenStream)
			If (<>usePW)
				$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey; <>SSLPassword; <>SSLcertificateINT)  //********************** ITK_SSLSetCert Added
			Else 
				$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey)  //********************** ITK_SSLSetCert Added
			End if 
		Else 
			$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff)
		End if 
	End if 
	
	DELAY PROCESS:C323(Current process:C322; 3)
	
	//**** inner loop to accept incoming connections
	Repeat 
		
		$i:=ITK_TCPStatus2A($t_stream; $t_status)
		
		//We test the status of each stream
		While ($i>0)
			Case of 
				: ($t_status{$i}=8)
					// stream connected !
					// we pop a delivery process number from the list 
					$msg:=ITK_RcvIPCMsg(2)
					If ($msg#"")
						$p:=Num:C11($msg)
						//we send a message with the stream ID to the Delivery process
						ITK_SendIPCMsg(1000+Num:C11($msg); String:C10($t_stream{$i}))
						//open a new stream to listen on
						If (<>useSSL)
							$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff; kITKSSLListenStream)
							If (<>usePW)
								$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey; <>SSLPassword; <>SSLcertificateINT)  //********************** ITK_SSLSetCert Added
							Else 
								$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey)  //********************** ITK_SSLSetCert Added
							End if 
						Else 
							$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff)
						End if 
						$t_status{$i}:=0
						//We check that the process was really asleep
						While (Process state:C330($p)#5)
							DELAY PROCESS:C323(Current process:C322; 1)
						End while 
						//We wake the process up
						RESUME PROCESS:C320($p)
						IDLE:C311
						
					Else   //($msg="")
						//There is no delivery process available...
						DELAY PROCESS:C323(Current process:C322; 6)
					End if 
					
				: (($t_status{$i}<0) | ($t_status{$i}>8))
					//The stream was dead before we could treat it...
					$err:=ITK_TCPRelease($t_stream{$i})
					If (<>useSSL)
						$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff; kITKSSLListenStream)
						If (<>usePW)
							$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey; <>SSLPassword; <>SSLcertificateINT)  //********************** ITK_SSLSetCert Added
						Else 
							$err:=ITK_SSLSetCert($t_stream{$i}; <>SSLcertificate; <>SSLkey)  //********************** ITK_SSLSetCert Added
						End if 
					Else 
						$t_stream{$i}:=ITK_TCPListen(0; 0; <>PortNum; $webBuff)
					End if 
					$t_status{$i}:=0
			End case 
			
			//Move on to the next stream to handle
			For ($j; $i+1; Size of array:C274($t_stream))
				If (($t_status{$j}>=8) | ($t_status{$j}<0))
					$i:=$j
					$j:=9999  // We found one
				End if 
			End for 
			If ($j<9999)  // We did not find any
				$i:=-1
			End if 
		End while   //Testing the status of each stream
	Until ($i<0)
Until (<>HTTP_stop)