//%attributes = {"publishedWeb":true}
// Method : HTTP_SendDoc(Stream;DocPath;Request)
// This method sends a file stored on disk.

// added byte range serving support

$fic:=$2
$sign:=Substring:C12($fic; Position:C15("."; $fic)+1; Length:C16($fic)-Position:C15("."; $fic))
$docLen:=Get document size:C479($fic)

$MIMEtype:=""
$cached:=False:C215
// ------ this has been added to provide HTTP client cache support ------
GET DOCUMENT PROPERTIES:C477($fic; $verrouille; $invisible; $Cdate; $Ctime; $Mdate; $Mtime)
$modified:=ITK_Secs2RFC(ITK_Date2Secs($Mdate; $Mtime; 1); 1)
If ($3="@If-Modified-Since:@")  //  the HTTP client uses a cache !
	// extract the modification date of its cached URL
	$lastMod:=Substring:C12($3; Position:C15("If-Modified-Since: "; $3)+19)
	$lastMod:=Substring:C12($lastMod; 1; Position:C15(Char:C90(13); $lastMod)-1)
	// convert it into GMT time
	If (ITK_Secs2RFC(ITK_RFC2Secs($lastmod); 1)=$modified)
		$cached:=True:C214
	End if 
End if 
// ------

If ($sign#"")
	// find the MIME Type of the requested document
	Case of 
			
		: (($sign="txt") | ($sign="text"))  // plain text
			$MIMEtype:="text/plain"
		: ($sign="hqx")  // BinHex file
			$MIMEtype:="application/mac-binhex40"
		: (($sign="html") | ($sign="htm"))  // HTML file
			$MIMEtype:="text/html; charset=utf-8"
		: ($sign="png")  // PNG files
			$MIMEtype:="image/png"
		: ($sign="gif")  // GIF files
			$MIMEtype:="image/gif"
		: (($sign="@.jpg") | ($sign="@.jpeg") | ($sign="@.jfif") | ($sign="@.pjpg"))  // JPEG file
			$MIMEtype:="image/jpeg"
		: ($sign="pict")  // PICT file
			$MIMEtype:="image/pict"
		: (($sign="@.mov") | ($sign="@.moov"))  // Quicktime Movie file
			$MIMEtype:="video/quicktime"
		: ($sign="sit")  // Stuffit file
			$MIMEtype:="application/x-stuffit"
		: ($sign="pdf ")  // PDF Acrobat File
			$MIMEtype:="application/pdf"
		Else 
			Case of 
				: (($fic="@.txt") | ($fic="@.text"))
					$MIMEtype:="text/plain"
				: ($fic="@.gif")
					$MIMEtype:="image/gif"
				: (($fic="@.jpg") | ($fic="@.jpeg") | ($fic="@.jfif") | ($fic="@.pjpg"))
					$MIMEtype:="image/jpeg"
				: ($fic="@.pict")
					$MIMEtype:="image/pict"
				: (($fic="@.mov") | ($fic="@.moov"))
					$MIMEtype:="video/quicktime"
				: ($fic="@.sit")
					$MIMEtype:="application/x-stuffit"
				: ($fic="@.hqx")
					$MIMEtype:="application/mac-binhex40"
				: ($fic="@.pdf")
					$MIMEtype:="application/pdf"
				Else 
					$MIMEtype:="text/html; charset=utf-8"
			End case 
	End case 
End if 

If ($MIMEtype#"")
	// we can send the file, so send the HTTP header        
	If (($3="get @") & ($cached=True:C214))
		$err:=http_SendHeader($1; "304 not modified"; "text/html; charset=utf-8")
		$err:=ITK_TCPSend($1; <>crlf)
		
	Else 
		If (Position:C15(<>crlf+"Ranges: bytes"; http_req)#0)
			$docLen:=http_SendRange($1; http_req; $MIMEtype; $modified; $fic; $docLen)
		Else 
			$err:=http_SendHeader($1; "200 OK"; $MIMEtype; $doclen)
			If ($modified#"")  // ------ added for cache support
				$err:=ITK_TCPSend($1; "Last-Modified: "+$modified+<>crlf; kITKBuffer)
			End if 
			$err:=ITK_TCPSend($1; <>crlf; kITKFlush)
			
			
			// send the file if method = GET (so that we also support method = HEAD)
			If (($3="get @") & ($fic#""))  // method = GET -> send the file
				If ($docLen<<>http_MaxCach)  // use the File cache
					If ($MIMEtype="@text@")  //ITK_V4
						$err:=ITK_TCPSend($1; U_GetTextBlock($fic); kITKFlush)
					Else 
						$err:=ITK_TCPSendBlob($1; U_GetBlob($fic); kITKFlush)
					End if 
				Else 
					$err:=ITK_TCPSendFile($1; $fic; kITKFlush)
				End if 
			End if 
			ITK_SendIPCMsg(1; $url)
		End if 
	End if 
Else 
	// the file doesn't exist or is a unknown type
	$err:=http_SendHeader($1; "404 ERR"; "text/html; charset=utf-8")
	$err:=ITK_TCPSend($1; <>crlf)
	$err:=ITK_TCPSend($1; "Error: document doesn't exist")
	//ITK_SendIPCMsg (1;$url+" ERR")
End if 