//%attributes = {"publishedWeb":true}
// Method : http_Server
// This method is called by http_Slave to serve an http request

// ITK Example of HTTP Server
// This example shows a basic implementation of HTTP serving HTML, GIF, JPEG,
// QuickTime, Stuffit and Binhex documents.
// ---------------------------------------------------

C_TEXT:C284(http_req; $temp; $url; $fic)
C_LONGINT:C283($err; $c; $s)

$c:=$1  // this is the streamRef on which we will receive the HTTP request

$nbKeepAlive:=0
Repeat 
	keep_alive:=False:C215
	$s:=ITK_TCPStatus($c; kITKStreamStatus)
	If ($s=8)  // stream still connected ?
		
		// receive HTTP request (ending with CRLF/CRLF, see RFC#1945 about HTTP)
		<>lHitNum:=<>lHitNum+1
		http_req:=""
		$err:=ITK_TCPRcv($c; http_req; <>http_MaxCach; 0; 0; <>crlf+<>crlf; 30*60)  // wait for the HTTP header (timeout after 30s)
		
		
		// do we accept keep-alive for this request ?
		If (http_req#"")
			If (http_req="@Connection: Keep-Alive@")
				$nbKeepAlive:=$nbKeepAlive+1
				If ($nbKeepAlive<<>MaxKeepAliv)
					keep_alive:=True:C214
				End if 
			End if 
			
			If (http_req="POST @")
				$len:=Num:C11(u_ExtractHeader(http_req; "Content-Length"))  //+Position(<>crlf+<>crlf;http_req)+3  //16/07/15
				// Wait for the end of data ending with a single ◊crlf (only if URL encoded)...
				
				$err:=ITK_TCPRcv($c; $temp; $len; 0; 0; <>crlf; 30*60)  // wait for HTTP data (timeout after 2mn) 120*60
				http_req:=http_req+$temp
			End if 
			
			If (ITK_TCPStatus($c)=kStreamStatusEstablished)
				// extract URL from the request (see RFC#1945 about HTTP)
				$url:=Substring:C12(http_req; 1; Position:C15(Char:C90(13); http_req))
				$url:=Substring:C12($url; Position:C15(" "; $url)+1)
				$url:=Substring:C12($url; 1; Position:C15(" "; $url)-1)
				
				Case of   // check if this URL must be processed (cgi-like) or if it is a real file
					: (http_req="get /search_emp@")
						http_search_emp($c; http_req)
						
					: (http_req="post /emp@")
						http_postemp($c; http_req)
						
					: (http_req="post /dept@")
						http_postdept($c; http_req)
						
					: (http_req="get /add_emp@")
						http_addemp($c; http_req)
						
					: (http_req="get @4dpict@")
						http_4DPict($c; http_req)
						
					Else 
						// convert URL to full pathname
						$fic:=<>WebFolder+Replace string:C233($url; "/"; Séparateur dossier:K24:12)  // Windows path aware !
						If ($fic=("@"+Séparateur dossier:K24:12))
							$fic:=$fic+"index.html"
						End if 
						http_SendDoc($c; $fic; http_req)
						If (http_hit_err=304)
							$url:=$url+" (cached)"
						Else 
							$url:=$url+" ("+String:C10(http_hit_len)+" bytes)"  // number of bytes sent
							<>lTransfered:=<>lTransfered+http_hit_len
						End if 
						If (keep_alive)
							$url:=$url+" *"+String:C10($nbKeepAlive)+"*"
						End if 
						http_SendLog($url)  // send our log record to the log process
				End case 
				
			End if 
		End if 
	End if   // http_req # "" ?
	
	If (keep_alive & (ITK_TCPChRcv($c)#0))  // do we keep the stream alive ?
		$err:=ITK_TCPSend($c; ""; 0)  // flush output buffer  
	Else 
		keep_alive:=False:C215
	End if 
	
Until (keep_alive=False:C215)